<template>
	<a-card :bordered="false">
		<a-form ref="searchFormRef" name="advanced_search" :model="searchFormState" class="ant-advanced-search-form mb-4">
			<a-row :gutter="24">
				<a-col :span="4">
					<a-form-item label="通知类型" name="logType">
						<a-select v-model:value="searchFormState.logType" placeholder="请选择" :options="logTypeOptions"/>
					</a-form-item>
				</a-col>
				<a-col :span="4">
					<a-form-item label="订阅事件" name="subscribesFlag">
						<a-select v-model:value="searchFormState.subscribesFlag" placeholder="请选择" :options="subscribesFlagOptions"/>
					</a-form-item>
				</a-col>
				<a-col :span="4">
					<a-button type="primary" @click="table.refresh(true)">查询</a-button>
					<a-button style="margin: 0 8px" @click="() => searchFormRef.resetFields()">重置</a-button>
				</a-col>
			</a-row>
		</a-form>
		<s-table
			ref="table"
			:columns="columns"
			:data="loadData"
			:alert="options.alert.show"
			bordered
			:row-key="(record) => record.id"
			:tool-config="toolConfig"
			:row-selection="options.rowSelection"
		>
			<template #operator class="table-operator">
				<a-space>
					<a-button type="primary" @click="formRef.onOpen()" v-if="hasPerm('sysUserWxOpenSendSetAdd')">
						<template #icon>
							<plus-outlined/>
						</template>
						新增
					</a-button>
					<a-button danger @click="deleteBatchSysUserWxOpenSendSet()" v-if="hasPerm('sysUserWxOpenSendSetBatchDelete')">删除</a-button>
				</a-space>
			</template>
			<template #bodyCell="{ column, record }">
				<template v-if="column.dataIndex === 'logRoleNames'">
					<a-tag v-for="textValue in record.logRoleNames" :key="textValue" color="green">
						{{
							textValue
						}}
					</a-tag>
				</template>
				<template v-if="column.title === '订阅' && hasPerm('sysUserWxOpenSendSetEdit')">
					<a-switch
						:loading="statusLoading"
						:checked="record.subscribesFlag === 'subscribe'"
						@change="editSwitch(record)"
					/>
				</template>
				<template v-else-if="column.title === '订阅' && record.subscribesFlag === 'subscribe'">
					订阅
				</template>
				<template v-else-if="column.title === '订阅' && record.subscribesFlag === 'unsubscribe'">
					取消订阅
				</template>
				<template v-if="column.dataIndex === 'action'">
					<a-space>
						<a @click="formRef.onOpen(record)" v-if="hasPerm('sysUserWxOpenSendSetEdit')">编辑</a>
						<a-divider type="vertical" v-if="hasPerm(['sysUserWxOpenSendSetEdit', 'sysUserWxOpenSendSetDelete'], 'and')"/>
						<a-popconfirm title="确定要删除吗？" @confirm="deleteSysUserWxOpenSendSet(record)">
							<a-button type="link" danger size="small" v-if="hasPerm('sysUserWxOpenSendSetDelete')">删除</a-button>
						</a-popconfirm>
					</a-space>
				</template>
			</template>
		</s-table>
	</a-card>
	<Form ref="formRef" @successful="table.refresh(true)"/>
</template>

<script setup name="sysUserWxOpenSendSet">
import {message} from 'ant-design-vue'
import Form from './form.vue'
import sysUserWxOpenSendSetApi from '@/api/biz/sysUserWxOpenSendSetApi'
import tool from "@/utils/tool";

let searchFormState = reactive({})
const searchFormRef = ref()
const table = ref()
const formRef = ref()
const statusLoading = ref(false)
const toolConfig = {refresh: true, height: true, columnSetting: true, striped: false}
const columns = [
	{
		title: '通知类型',
		dataIndex: 'logType'
	},
	{
		title: '通知角色',
		dataIndex: 'logRoleNames'
	},
	{
		title: '订阅',
		dataIndex: 'subscribesFlag',
		width: '80px'
	},
	{
		title: '创建时间',
		dataIndex: 'createTime',
		width: '150px'
	},
	{
		title: '更新时间',
		dataIndex: 'updateTime',
		width: '150px'
	},
]
// 操作栏通过权限判断是否显示
if (hasPerm(['sysUserWxOpenSendSetEdit', 'sysUserWxOpenSendSetDelete'])) {
	columns.push({
		title: '操作',
		dataIndex: 'action',
		align: 'center',
		width: '150px'
	})
}
let selectedRowKeys = ref([])
// 列表选择配置
const options = {
	alert: {
		show: false,
		clear: () => {
			selectedRowKeys = ref([])
		}
	},
	rowSelection: {
		onChange: (selectedRowKey, selectedRows) => {
			selectedRowKeys.value = selectedRowKey
		}
	}
}
const loadData = (parameter) => {
	const searchFormParam = JSON.parse(JSON.stringify(searchFormState))
	return sysUserWxOpenSendSetApi.sysUserWxOpenSendSetPage(Object.assign(parameter, searchFormParam)).then((data) => {
		return data
	})
}
// 开关
const editSwitch = (record) => {
	statusLoading.value = true
	sysUserWxOpenSendSetApi
		.sysUserWxOpenSendSetSubmitForm({"id": record.id, "subscribesFlag": record.subscribesFlag === 'subscribe' ? 'unsubscribe' : 'subscribe'}, false)
		.then(() => {
			table.value.refresh(true)
		})
		.finally(() => {
			statusLoading.value = false
		})
}
// 删除
const deleteSysUserWxOpenSendSet = (record) => {
	let params = [
		{
			id: record.id
		}
	]
	sysUserWxOpenSendSetApi.sysUserWxOpenSendSetDelete(params).then(() => {
		table.value.refresh(true)
	})
}
// 批量删除
const deleteBatchSysUserWxOpenSendSet = () => {
	if (selectedRowKeys.value.length < 1) {
		message.warning('请选择一条或多条数据')
		return false
	}
	const params = selectedRowKeys.value.map((m) => {
		return {
			id: m
		}
	})
	sysUserWxOpenSendSetApi.sysUserWxOpenSendSetDelete(params).then(() => {
		table.value.clearRefreshSelected()
	})
}
const logTypeOptions = tool.dictList('异常分类')
const subscribesFlagOptions = tool.dictList('订阅类型')
</script>
